
$Header: /net/objy27/wrld/mnt11/ricks/src/master/xrn/ChangeLog,v 1.8 1993/02/04 18:21:43 ricks Exp $

XRN release 6.18:

- More bug fixes and cleanup than humanly possible
	Jonathan I. Kamens	<jik@pit-manager.mit.edu>

- Faster entry into groups with lots of 'marked as unread' articles.	
	Per Hedeland		<per@erix.ericsson.se>

- xrn.ignoreNewsgroups - ability to specify groups (regular expressions)
  that you never want to see (even in the new groups window).  See the
  man page for more information.  This can really cut down the size of your
  .newsrc file and the memory usage of XRN.
	Jonathan I. Kamens	<jik@pit-manager.mit.edu>

- XRN now supports _ANSI_C_SOURCE, _POSIX_SOURCE, _XOPEN_SOURCE, and other 
  standard-based defines, and thus is less vendor-specific (but clearly some
  still exists...).
	Marc Evans		<evans@zk3.dec.com>

- Support for Motif 1.2 and cleanup of the cancel button
	David Brooks		<dbrooks@osf.org>

- No more claims of X11R3 support.

- Performance Improvements (less fetching across NNTP)
	Jim Graham		<flar@sun.com>

- Permissions of the .newsrc file are not changed - previously after an
    update the .newsrc file would have the permissions specified in the umask
	Rick Spickelmier	<ricks@objy.com>

- Settable Icon Pixmap and Name for normal, busy, and unread news modes
    - via the resources/options: iconName, iconPixmap, busyIconName,
				 busyIconPixmap, unreadIconName,
				 unreadIconPixmap
	Michael Salmon		<Michael.Salmon@eos.ericsson.se>

- Translation of Articles from ISO 646 to ISO 8859-1
	Michael Salmon		<Michael.Salmon@eos.ericsson.se>

- User settable number of characters in the subject line, via
    the indexLineLength resource/option
	Michael Salmon		<Michael.Salmon@eos.ericsson.se>

- Support for INN (InterNet News)
	Brendan Kehoe		<brendan@eff.org>

- XRN now can refile to RMAIL folders (use @folder, like MH +folder)
	Michael Thomas		<mike@gordian.com>

- The information box now tells you that articles posted to moderated 
  groups are sent to the moderator.
	Rick Spickelmier	<ricks@objy.com>

- Xtoolkit work processes now do the prefetching of the next group
    (can be disabled by defining NO_IMMEDIATE_WORK_PROC_PREFETCH)
	Marc Evans		<evans@zk3.dec.com>
	Jonathan I. Kamens	<jik@pit-manager.mit.edu>

- XRN now puts in the display name for editorCommand:
    xrn.editorCommand: xterm -display %D -e vi %s
    (%s for file name - must be specified, %D for display name, 
    this is optional)
	Rick Spickelmier	<ricks@objy.com>

- New Default: xrn.onlyShow number
    Only grab the header information for the last 'number' of articles
    in each group.  This is useful if you have been away for a while 
    and only want to see that last 100 or so articles in each group.
	Rick Spickelmier	<ricks@objy.com>

- Support for multiple signature files
    The appropriate signature file is the usual signature file name
    `~/.signature' followed by either a `-' and a  newsgroup name
    substring, or followed by a `.' and `followup', `forward', `gripe',
    `reply' or `post' according to the posting mode.  For example if you
    want to post a followup article in comp.sources.x then xrn uses the
    first valid signature file in the following order:

		    ~/.signature-comp.sources.x
		    ~/.signature-comp.sources
		    ~/.signature-comp
		    ~/.signature.followup
		    ~/.signature

	Nathan Maman		<Nathan.Maman@sophia.inria.fr>

- Support for executable signature files.  See 'executableSignatures'
  and 'localSignatures' in the man page.
	Nathan Maman		<Nathan.Maman@sophia.inria.fr>
	David Brooks		<dbrooks@osf.org>
	Jonathan I. Kamens	<jik@pit-manager.mit.edu>

- XRN now unconditionally saves articles when posted via `editorCommand'.
        Conrad Kimball	        <cek@sdc.boeing.com>

- Set up defaults for reasonable line folding (of course, it's my definition
	of reasonable).
	Rick Spickelmier	<ricks@objy.com>

- Fix for bad newsgroup names
	Per Hedeland		<per@erix.ericsson.se>
	Jonathan I. Kamens	<jik@pit-manager.mit.edu>
	Rick Spickelmier	<ricks@objy.com>

- XRN was reading the header information twice when `doing the right thing'
	Per Hedeland		<per@erix.ericsson.se>

- More XRN icons - xrn2.icon (news) and xrn3.icon (no news)
       Rainer Klute		<klute@irb.informatik.uni-dortmund.de>

- Scrolling actions now exist for the subject index window
	    (artScrollIndex and artScrollIndexBack)
	Greg Schroeder		<greg@sharebase.com>
	
- Support for DEC Alpha OSF/1
	Eric Muller		<muller@src.dec.com>
	Rick Spickelmier	<ricks@objy.com>
	Dave Hill		<ddhill@aosf.gsf.dec.com>

- Apollo 10.3.5 support
	Keith Cantrell		<kcantrel@core1.hssc.ksc.nasa.gov>

- Amiga-UNIX support
	Craig M. Votava		<ihlpf!cmv>

- Reconnecting to server after time out will update the internal 
  data structures (new articles, etc.).
	Rick Spickelmier	<ricks@objy.com>

- Bug fixes
	David Brooks		<dbrooks@osf.org>
	Bob Ellison		<ellison@sei.cmu.edu>
	Marc Evans		<evans@decvax.dec.com>
	Jim Graham		<flar@eng.sun.com>
	Jonathan I. Kamens	<jik@pit-manager.mit.edu>
	Andy Linton		<Andy.Linton@comp.vuw.ac.nz>
	Nathan Maman		<Nathan.Maman@sophia.inria.fr>
	Dale Moore		<Dale_Moore@cs.cmu.edu>
	Taed Nelson		<nelson@berlioz.nsc.com>
	Michael Salmon		<Michael.Salmon@eos.ericsson.se>
        Peter J. Scott		<pjs@euclid.jpl.nasa.gov>
	Rick Spickelmier	<ricks@objy.com>
	Jean-Philippe Martin-Flatin	<syj@ecmwf.co.uk>
	Philip Yzarn de Louraille	<yzarn@chevron.com>
	Jason C. Austin		<sun!larc.nasa.gov!j.c.austin>


XRN release 6.17:

- Bug fixes
	Per Hedeland                <per@erix.ericsson.se>
	Jonathan I. Kamens          <jik@pit-manager.mit.edu>
	Bill Stapleton <sun!csd4.csd.uwm.edu!wls>

- extraMailHeaders
    When replying via mail to a posting, include or do not include an
    "X-Newsgroups:" line with the newsgroups list from the posting and a
    "In-reply-to:" line with its message ID.
	Jonathan I. Kamens          <jik@pit-manager.mit.edu>

- Better handling and display of INEW error conditions.
 	Bob Ellison <ellison@sei.cmu.edu>

- re-edit
    You can now re-edit mail messages and postings when using 'editorCommand'
    editors.
 	Bob Ellison <ellison@sei.cmu.edu>

- Support for RS6000
        Marc Pawliger	<sun!ibmpa.awdpa.ibm.com!marc>

XRN release 6.17beta:

- CNEWS data field fix
  Andy Linton <sun!comp.vuw.ac.nz!Andy.Linton>

- fixed DOTDIR handling
  Andy Linton <sun!comp.vuw.ac.nz!Andy.Linton>

- massive improvements to compose.c
  Jonathan I. Kamens <jik@pit-manager.mit.edu>

    Bug							When it occurs
    ----------------------------------------------	-----------------
    When aborting an article or message, no		Always.
    distinction is made between articles and
    messages in the info messages.

    When being asked to confirm sending or		Non-null editorCommand.
    re-editing an article or message, no
    distinction is made between articles and
    messages.

    When posting a message from Newsgroup mode,		Null editorCommand.
    the cursor should be positioned on the
    "Newsgroups:" line of the header because it
    needs to be filled in.

    When posting a message from Article mode, the	Null editorCommand.
    cursor should be positioned on the "Subject:"
    line of the header because it needs to be
    filled in.

    When posting a gripe, there's an extra blank	Always.
    line at the top of the gripe template.

    When posting a gripe, the cursor should be		Null editorCommand.
    positioned at the beginning of the first
    field to be filled in.

    When posting a followup, the signature file		Null editorCommand.
    is not included at the bottom of the message.

    When sending a reply, the signature file is		Null editorCommand.
    not included at the bottom of the message.

    When forwarding a message, the cursor is		Null editorCommand.
    positioned one character too far to the left
    on the "To: " line.

    When including article text in a reply,		Null editorCommand,
    followup or forwarded message, includeCommand	non-null includeCommand.
    is ignored.

    When including the article text in a reply,		Null editorCommand.
    followup or forwarded message, the text is
    included one line at a time and gets inserted
    rather slowly.

    I think that's probably about it.  In addition to the bugs that are
    mentioned above, two other user-visible changes have been made:

    1) The editor command is now executed with the bourne shell, rather than
    the C shell, since that's what people expect commands run from programs
    to be executed with.  This should probably be controllable through an X
    resource, but if it isn't going to be, then sh is a better default than
    csh.  In any case, if someone wants to use csh, they can put "/bin/csh
    -fc ..." in the resource.

    2) The includeCommand resource is now expected to have only *two* %s in
    it, rather than three.  The first is replaced by the prefix, and the
    second is replaced by the article file name.  The filter is expected to
    output to stdout.

- found serious core leaks
  Jim Rees <rees@citi.umich.edu>

- clean up of the XRN man page
  Jonathan I. Kamens <jik@pit-manager.mit.edu>

- replyTo works for mail also

- check for invalid newsgroups

- kill subject returns to next unread after subject entry, not first
  unread

- added support for DOTDIR
  Michael Salmon <Michael.Salmon@eos.ericsson.se>

- speed ups
  Boyd Roberts <boyd@prl.dec.com>

- 'verboseKill: false' now eliminates all messages.

- i386 support
  Jonathan I. Kamens <jik@pit-manager.mit.edu>

- includeCommand resources
  Nathan Maman                <sun!mirsa.inria.fr!Nathan.Maman>

  I've added the resource `includeCommand'.  It is a sprintf'able
  string with `%s' arg where the includePrefix and the article file name.

  For example, you can put the following line in your .Xdefaults:

      XRn.includeCommand: xmh-insert-reply -s '%s' %s

- 'P' for printed
  Nathan Maman                <sun!mirsa.inria.fr!Nathan.Maman>

- XRN now detects detects write failures when updating the .newsrc file
  (such as file system full, disk going off-line, etc).

- Works around horrible parsing done in `inews' for the newsgroups line.

- new option: xrn.lockFile, xrn -lockFile
	set the name of the file used for locking multiple XRN runs.
	(use:  xrn -lockFile .xrnlock-sports -newsrcFile .newsrc-sports)

- new option: ccForward resource (with the "CC" class) to cause
  forwarded messages to be CC'd to the author.
	Jonathan I. Kamens <jik@pit-manager.mit.edu>

- new icon
	sun!oskeewow.b23b.ingr.com!tracy (Robert Tracy)

- changes for to allow building with X11R5
	Jonathan I. Kamens <jik@pit-manager.mit.edu>

- improvements to the Imakefile
	Marc Evans <evans@decvax.dec.com>

- bug fixes
	Jonathan I. Kamens <jik@pit-manager.mit.edu>
	Dale Moore <Dale.Moore@cs.cmu.edU>
	Mike Yang <mikey%eukanuba.wpd@sgi.com>
	Harper Mann <harper@mips.com> 
	David Brooks	<dbrooks@osf.org>
	Alec Wolman <sun!crl.dec.com!wolman>
	Michael Burns <sun!chem.psu.edu!burns>
	Boyd Roberts <sun!prl.dec.com!boyd>
	Andy Sherman <andys@ulysses.att.com>
	Tevfik Karagulle <tev@cama01.uio.no>
	Dave Lemke <sun!ncd.com!lemke>

- new resource for use with the 'refile' option, mhPath, sets the path
	to use for finding 'refile'
	Andrew Wason <aw@rruxi.bae.bellcore.com>

- new resource to watching for new news, watchUnread
If the resource is not set or empty, i.e.

XRn*watchUnread:	

then the current behavior applies.  We set it in our XRn file to our
organization group and the "empty" option lets users reset it to "all".
		SEI




XRN release 6.16:

- never really released...



XRN release 6.15:

- environments tested on:
	Ultrix: twm, MOTIF widgets
	Ultrix: tvtwm, MOTIF widgets
	Ultrix: mwm, MOTIF widgets
	Ultrix: mwm, DEC widgets
	Ultrix 3.1, 4.0, 4.1: mwm, Athena widgets
	Sun 4, SunOs 4.0.3c: mwm, Athena widgets
	Apollo Domain/OS SR10.3

- Ability to change the mouse cursor color
       (pointerForeground, pointerBackground)
	Casey Leedom <casey@gauss.llnl.gov>

- On Apollo, the ORGANIZATION environment variable is called NEWSORG

- Local time support for Ultrix and Apollo
	Jim Rees (rees@citi.umich.edu)

- Handling of a.b.c.d format for NNTPSERVER
	Jim Rees (rees@citi.umich.edu)

- Changes to Imakefile to support Saber
	Jonathan I. Kamens          <jik@pit-manager.mit.edu>

- Text field in dialog boxes now resizes to fit the initial text string

- The composition pane now uses the USER and FULLNAME environment variables
	Jonathan I. Kamens          <jik@pit-manager.mit.edu>

- Follow-up to poster handled
	Jonathan I. Kamens          <jik@pit-manager.mit.edu>

- The leaveHeaders resource now supports the 'all' (all fields) keyword
  and the stripHeaders resource now supports the 'none' keyword.
  See the man page for an explanation.
	Jonathan I. Kamens          <jik@pit-manager.mit.edu>

- If you're running 1.5.11 NNTP or better, define NNTP_REREAD_ACTIVE_FILE
  to cut down on the time it takes to do a rescan.  This assumes that
  this works that way I was told it does...
    
- Updates to the Motif support
	Mike Yang                   <mikey%eukanuba.wpd@sgi.com

- Support for `vfork' - spawning processes was taking a long time
  (spawning editors now uses vfork and a simple popen was writen
  that uses vfork - ultrix popen uses fork, argh!!)

- Carriage return (with the cursor in the message dialog) will now dismiss
  the message dialog

- The message dialog now tells you explicitly whether a mail message was
  sent or an article was posted

- Forwarding a message now creates a subject line based on the article
  group and number
	Bob Ellison		    <ellison@sei.cmu.edu>

- a few key bindings have been added to all and add modes
  (1 each, quit)

- Lots of bug fixes
	Jonathan I. Kamens          <jik@pit-manager.mit.edu>
	Per Hedeland                <per@erix.ericsson.se>
	Nathan Maman		    <sun!mirsa.inria.fr!Nathan.Maman>

- Save now supports MH refile - specify '+folder' in the save dialog
	Bob Ellison

- lexer modified so alt.stupid.putz^H^H^H^Hkutz.putz would be accepted

- composition pane fixes
	Per Hedeland                <per@erix.ericsson.se>

- save fixes (>From)
	Per Hedeland                <per@erix.ericsson.se>

- error checking on article storage
	Per Hedeland                <per@erix.ericsson.se>

- some (but not all) memory leaks plugged...


XRN release 6.14:

- next newsgroup / fed up cursor positioning bug fixed!

- articles marked as unread will not be marked read by catch up and fed up

- checkpoint button added to article mode (artCheckPoint)

- line count can now be displayed in the subject index window
    (use -displayLineCount)
    Chris P. Ross               <cross@eng.umd.edu>

- search regex groups in newsrc order
    Per Hedeland                <per@erix.ericsson.se>

- new tempnam.c function, posting bug fixed
    Jonathan I. Kamens          <jik@pit-manager.mit.edu>

- author full name is controlled by a resource now, not a config parameter
    (+/-authorFullName)
    Mike Yang                   <mikey%eukanuba.wpd@sgi.com

- MOTIF support for the new scrolling buttons
    Mike Yang                   <mikey%eukanuba.wpd@sgi.com

- Modified Action procedure calling:

    Modified the calling sequence for the Action procs so that they pass 
    the other parameters (event, parameters, and count) to the Function 
    procs.  This allows the actions to be able be given strings.  I used 
    this to modify artSaveFunction to save using the given argument. 
    In my case, I modified the app-defaults file so that F6 calls artSave 
    with "| mail dce".  [added '%' in article mode to pipe the article 
    through uudecode - ricks]
    David Elliott               <dce@smsc.sony.com>

- configuration now based on SYSV defined, not BSD defined
    Casey Leedom		<casey@gauss.llnl.gov>

- default print command passes 8-bit characters (for French sites)
    Marcin Skubiszewski		<skubi@prl.dec.com>

- toggle groups changed to List Old and the output is in a new format
    When a group contains only old news, the corresponding line is
    	"       news in misc.misc ..."
    instead of the old (and wrong)
    	"Unread news in misc.misc ..."
    similarly, when a group is totally empty (which is unfrequent), the
    line reads
    	"            in misc.misc ..."
    Marcin Skubiszewski		<skubi@prl.dec.com>

- new button in article mode: list old (artListOld)
    lists all articles available in the group
    Marcin Skubiszewski		<skubi@prl.dec.com>

- new format for "Unread news" lines in newsgroup mode
    	"Unread news in misc.misc          3 articles   + 350 old"
    where "+ 350 old" means that misc.misc contains 350 old messages.
    This count is not always right, but it is right for the newsgroups
    which never expire
	Marcin Skubiszewski <skubi@prl.dec.com>

- new resources: saveString and resetSave.
    saveString sets the default string to go in the Save dialog (the
    default is the empty string, as before), and resetSave affects
    whether or not the SaveString variable gets reset for each newsgroup.
    David Elliott               <dce@smsc.sony.com>

- fix so word wrapping works correctly
    Jim Graham			<flar@eng.sun.com>

- various bug fixes
    Marc Evans			<evans@decvax.dec.com>
    Mike Yang                   <mikey%eukanuba.wpd@sgi.com
    Jonathan I. Kamens          <jik@pit-manager.mit.edu>
    Per Hedeland                <per@erix.ericsson.se>
    Casey Leedom		<casey@gauss.llnl.gov>
    Marcin Skubiszewski		<skubi@prl.dec.com>
    Greg McNutt			<gcmcnutt@mlsgcm.Ebay.sun.COM>

- man page updated (and flags/options now in alphabetical order)


XRN release 6.13:

- signature file is not automatically included if compiled with the 
  INEWS_READ_SIG option (see config.h)
   David Elliot			<dce@smsc.sony.com>
- display local time instead of GMT (only works for SYSV machines right now,
  how do you do it for a non-SYSV machine?)
  (see USE_LOCALTIME and +/-displayLocalTime)
    Mike Yang			<mikey%eukanuba.wpd@sgi.com>
- the default distribution can now be set
  (see DISTRIBUTION and -distribution)
- C-News does not (by default) reset the low number of the newsgroups
  in the news active file, however many sites have programs to do this.
  If you do, define FIXED_C_NEWS_ACTIVE_FILE)
- the goto newsgroup dialog now takes substrings and regular expressions
- new button in newsgroup mode: 'toggle groups', display all groups that
  are currently subscribed to.
- SVR4 fixes
   David Elliot			<dce@smsc.sony.com>
- better editorCommand failure return information
   David Elliot			<dce@smsc.sony.com>
- bug fixes
  - toggle header, rot13, typeahead
    Per Hedeland		<per@erix.ericsson.se>
- scroll bar stuff
    Dan R. Greening		<dgreen@cs.ucla.edu>
- scrolling
    Jim Graham			<flar@eng.sun.com>
- man page has been updated somewhat (still probably a bit out of date)
- new defines for machines that don't have TEMPNAM and STRSTR
	(see config.h)


XRN release 6.12:

- a little faster (better use of X toolkit functions)
- word wrapping of postings and mail fixed
- uses less memory
    jhsu@wsl.dec.com (define STUPIDMMU in config.h)
- fix for C-news low article number problem:
	C-new does not update the low article number in the active file...
	murphy@ufp.dco.dec.com
- Motif support
	- add -DMOTIF to the compiler flags in the Imakefile
	- link with -lXm rather than -lXaw and -lXmu
	mikey%eukanuba.wpd@sgi.com
- icon title change for unread news
	mikey%eukanuba.wpd@sgi.com
- addition of ansi-c prototypes 
	mikey%eukanuba.wpd@sgi.com
- better author parsing (for author full name)
	Odd Einar Aurbakken <oea@ifi.uio.no>
- author full name in subject window (define AUTHOR_FULLNAME in config.h)
	(also can be controlled by a resource, mikey%eukanuba.wpd@sgi.com)
- direct use of inews when posting (also: haozhou@acsu.buffalo.edu (hao zhou))
	Odd Einar Aurbakken <oea@ifi.uio.no>
- verboseKill option
	Odd Einar Aurbakken <oea@ifi.uio.no>
- artLast, artNext now show proper unread count



XRN release 6.11:

- editorCommand program is now a separate process
- groups of articles can now be saved as a group
	- select a group of articles, hit 'save',
	  if a '%d' is in the string typed into the dialog box,
	  it will be replaced with the article number.
- organization can now be set from the environment
	(per@erix.ericsson.se)
- xrn -help no longer removes the lock file
- accelerators can now be specified in your resources file
	(jik@pit-manager.mit.edu)
- much better error handling and recovery
	(jik@pit-manager.mit.edu)
- fixed freeing of a non-malloced structure
	(mikey@eukanuba.wpd.sgi.com)
- added blank lines in compositions
	(mikey@eukanuba.wpd.sgi.com)
- lots of cleanup
	(jik@pit-manager.mit.edu)
- fixed core dump problem
	(jik@pit-manager.mit.edu)
- moved information dialog defaults to application defaults file
	(jik@pit-manager.mit.edu)
- 'Message-ID' and 'Date' now added to postings and followups
	(drw900@anusf.anu.edu.au)
     - in my opinion, this is really the responsibility of the NNTP
       server and news readers/posters have no business generating 
       these fields...  but there are a few NNTP servers that don't
       do it (or don't spawn an inews that does it)
       GENERATE_EXTRA_FIELDS in config.h turns on the generation of 
       these 2 fields
- got rid of 'Cc: user' on forwards
- new resource (xrn.cc), allows the user to specify if a 'Cc' should
  	be added to a reply.
- newsgroup names can now have '$' in them
	(dgreen@cs.ucla.edu + others)
- "--" now separates signatures and messages when posting



XRN release 6.10:

- usage message can be requested when another xrn is running
	(lock file is not checked until later on)
- title and iconName can be specified via X resources
	(per@erix.ericsson.se)
- tmpDir is now tilde expanded
- artFedUp now allowed to have a confirm box
- changes to XRn.ad
	(jik@pit-manager.mit.edu)
- better error handling in article saving code (and faster saving)
	(jik@pit-manager.mit.edu)
- better handling of form feeds in articles
	(per@erix.ericson.se)
- added 'Cc: user' to mail messages
- fixed bug that caused a core dump during automatic rescan
	(per@ericom.ericsson.se)
- made prefetch_max a resource
	(evans@decvax.dec.com)
- xrn.includePrefix for setting the include article text prefix
	(defaults to "|> ")
- popups fixed
	(jik@pit-manager.mit.edu)
- handles newsgroups of type 'x'
	(jik@pit-manager.mit.edu)
- newsgroup names can now contain '&'
- better handling of multiple messages in the information dialog
- version number of XRN now stored in XRn.ad, so on startup XRN
  can determine if the XRn.ad file is in sync with XRN
- xrn.cancelCount for specifying how many articles to scan before
	popping up the 'cancel search' button
- added another way to specify the senders actual address (RETURN_HOST,
	see config.h) (phil@BRL.MIL)
- better core dump handling, now a resource (xrn.dumpCore)
	(jik@pit-manager.mit.edu)
- probably more that we forgot about...



XRN release (6.9):

- support for gould machines (Hugues.Leroy@irisa.fr)
- fixed XRn.ad:
	missing colon: jqj@rt-jqj.stanford.edu (JQ Johnson)
	reordering bindings: he@idt.unit.no (Haavard Eidnes)
- commented out the following from Xresources.sample:
	xrn.organization: UC Berkeley IC CAD Group
	xrn.replyTo: ricks@berkeley.edu
  users were copying the entire file verbatim and I was getting
  replies to articles posted by others...
- better `info line' messages for some of the buttons
- bug fixes to compose (many authors)
- ANSI-C updates for mesg.{h,c}: Ken Raeburn <Raeburn@ATHENA.MIT.EDU>
- bug fixes ito XFILESEARCHPATH code


XRN release (6.8):

- bug fixes
  - signature file now in the right place (various authors)
- XRN now detects if the application defaults file has not been installed
- posting group fix
- artFedUp
- documentation on widget hierarchy
- cancel button for stopping searches


XRN release (6.7):

- bug fixes
  - now return to the right now after next newsgroup
   (Jonathan I. Kamens <jik@pit-manager.mit.edu>)
  - button box size at start is correct
   (Jonathan I. Kamens <jik@pit-manager.mit.edu>)
  - topLines now works
- faster newsrc file backup
   (Jonathan I. Kamens <jik@pit-manager.mit.edu>)
- mail messages are now wordwrapped in the same manner that articles are
   (Jonathan I. Kamens <jik@pit-manager.mit.edu>)
- updated XRn.ad file
  - default button labels, fixed key bindings, grips removed
    (us, Salvador Pinto Abreu <spa@fctunl.rccn.pt>,
    and Jonathan I. Kamens <jik@pit-manager.mit.edu>)
- scroll and doTheRightThing work again (just like they did in the R3 version)
  - a backwards scroll function also exists, default bound to 'b'
- SHORT_ICONNAME
  - define this to keep your icon title small
    (Mike Yang <mikey@wsl.dec.com>)
- user-settable command button labels
  - see XRn.ad
    (Salvador Pinto Abreu <spa@fctunl.rccn.pt>)
- select newsgroup / article
  - click with the middle button in the index window (top text window)
    on a newsgroup entry to enter the group, on a subject entry to read 
    an article (just like the old double clicking)
    (Salvador Pinto Abreu <spa@fctunl.rccn.pt>)
- better Imakefile 
  - handles the use of installed libraries better
    (Mark Hastings <hastings@walnut.berkeley.edu>)
  - handles saber
   (Jonathan I. Kamens <jik@pit-manager.mit.edu>)
- XFILESEARCHPATH added, see config.h
   (Jonathan I. Kamens <jik@pit-manager.mit.edu>)

- the name of the article text widget was changed from
  "text" to "articleText"


XRN release (6.6):

- xmkmf
- IBM RT AOS patches
  (Keith Moore <moore@cs.utk.edu>)
- titlebar removed and the title and iconName resources are set to
  what the titlebar originally contained (you can define TITLEBAR in
  config.h to get it back)
- pane bug fix:
	Thanks!  aw@rruxi.bae.bellcore.com (Andrew Wason)

XRN release (6.5):

NOTES:

- R3 support has not been tested
- editorCommand has not been tested
- VMS support has not been tested

- X11R4 support (define R3 to get R3 support, see config.h)
    - use 'xrn*ShapeStyle: Oval' to get rounded buttons
- subscribes to groups that are entered via "goto group"
- ALT-MAILER-2 (Marc Evans <evans@decvax.dec.com>)
- NO_SENDMAIL removed, now use ALT-MAILER-2
- PRINTER (???)
- if you goto a group from all mode, exiting the group will return you to
  all mode
- mail messages are now folded in the same manner that article submissions
  are folded
- bug fixes:
  - using wrong text widget in some 'all mode' functions
	(Mark J. Kilgard <@rice.edu:mjk@uncle-bens.rice.edu>)
  - mesgPane is no longer editable
  - freeing some already freed (or never allocated) memory
- if the lock file is on the same host and the xrn process is no longer
  running, the lock file will be updated and xrn will be allowed to run
- save file name is not saved across newgroups


XRN release (6.4):

- documented xrn.info: on/off (xrn +/-info)
- new define, FIXED_ACTIVE_FILE.  Define this if your news system
  defines its active file format such that if the first article number
  and the last article number are the same, there are no articles
  available (see config.h).  This will speed up 'rescan' and startup.
- support for Swedish characters in group names
- new option: +/-typeAhead, +typeAhead allows typeahead, -typeAhead
  disallows typeahead.
- bug fixes
  - temp files were being left around if a posting was aborted
  - fixed bugs from interacting buttons
  - fixed timeOut problems
  - fixed type-ahead, DO_NOT_EAT_TYPE_AHEAD gotten rid of


XRN release (6.3):

- bug fixes
- eats type-ahead (I think... - #define DO_NOT_EAT_TYPE_AHEAD in config.h
	if you don't like this feature)
- alternate mailer - calls 'send' rather than 'sendmail', 
  allowing 'mh' aliases to be used (see the file ALT-MAILER)
	(thanks to Chris Tengi <tengi@Princeton.EDU>)
- auto rescan (see the description of -rescanTime in the man page)
	(see RESCAN_TIME in config.h)
- informational messages to the Information window can be turned off
	(see +/-info, xrn.info: on/off)
- better internal specification of buttons
- busy cursor works for key bindings and double clicking
- new defines: RESOLVER, NO_SENDMAIL, (see the file config.h)
	(thanks to Greg Wohletz <greg@duke.cs.unlv.edu>)
- new hobbes bitmaps (to keep Calvin company)
	(thanks to me and mead!devil!dem@decwrl.dec.com (Dave Myers))
- cancel authorization check
	(thanks to <asjl@comp.vuw.ac.nz> Andy Linton)


XRN release (6.2.1):

- include config.h in cursor.c and utils.c
- removed sys/file.h from source files (included via X11/Xos.h)
- change #if SYSV_REGX to #ifdef SYSV_REGX in cursor.c
- fixed app defaults installation
- fixed width and height in app defaults
- composition window name change to "Composition"
- include file box would segv, fixed
- moved getinfofromfile to internals.c so other
  implementations of clientlib can be used
- added v{f,s}printf for those that don't have it in libc.a
- added strtok for those that don't have it in libc.a
- documented the new confirm boxes
- goto article screwed up for out of range article number, fixed
- indef's added so file/org/domain defines can be done in the
  Imakefile
- char -> int in compose.c
- added button for scrolling


XRN release (6.2):

bug fixes
- print for VMS fixes (misinstalled patch)
  [thanks to Kevin Herbert <herbert@gr8ful.enet.dec.com>]
- popup dialogs work better with sticky focus window managers
  [thanks to mikey@wsl.dec.com (Mike Yang)]
- added ':' to the end of the Article %ld in %s line in saved articles
  (allows various mail programs to work on saved articles)
- installing add mode translations could occasionally core dump
- next newsgroup should work better now (no core dumps or infinite loops)
- fixed a few infinite loops
- the articles that have been read are no longer lost when you unsubscribe
  to a group

key bindings are no longer lost after using pop up dialogs.

information box geometry can now be specified:
	xrn.Information.geometry: 

articles can now be sorted by subjects.  See xrn.sortedSubjects.
  sorting is case insensitive and based on the first 24 characters

"include file" now does tilde expansion

posting failures put you back in the composition window

default action for confirm dialog boxes is now 'yes'.

support for the macII running A/UX 1.1 (System V Rel 2 with BSD networking)
  [thanks to glenn@mathcs.emory.edu (Glenn T. Barry)]

support for HPUX
  [thanks to jp@hplb.hpl.hp.com (Julian Perry)]

even better kill file support
- regular expressions are supported in the kill pattern
  (still missing: all the various possible commands that can be used)
- better kill file entries generated

NN 'Re^#:' is understood and dealt with.

confirm boxes are now available on a per-button basis.
See xrn.confirm in the man page.
p
subject next now uses a case insensitive/24 character comparision

rn bindings are in the app-defaults file and are now the default bindings

internals
- better 'mesgPane' interface
  [thanks to mtoy%there.esd.sgi.com@sgi.sgi.com (Michael Toy)]


XRN release (6.1):

bug fixes
  - insertion point for compose windows now in the right place
  - tabs and new lines can now be in *ButtonList: X resources
  - occasionally xrn would die due to not being able to open
    the newsrc temp file - this has been fixed
  - garbage text in error label during subject next gotten rid of
  - group names can now be longer than 32 characters
	'hp-factory.software-eng.excalibur' can now be read
  - busy cursor appears all of the times when XRN is busy
  - top window redraws correctly - going from all/ng mode to
    article mode, if the group was empty, you would pop back out
    to all/ng mode, but without any text in the top window
  - control C now aborts a subject search
  - exiting out of All mode had some problems
    (thanks to Rich Simoni <simoni@strat.stanford.edu>)

popup mesg window
  - no more output to stderr
  - much of the error/warning output that went to the top info/help
    label now goes to the mesg window

defines to deal with various toolkit/window manger problems
  - see config.h

confirm box on XRN quit/exit

key bindings now work in all widgets, not just the button box

VMS support (thanks to Kevin Herbert <herbert@gr8ful.enet.dec.com>)

xrn checks to see if another xrn is running - the .rnlock file
  used by rn is not used.  XRN stores the host that XRN is running
  on in addition to the process id.

key bindings are now exported:
  - four new resources/command line options:
	addBindings, artBindings, allBindings, ngBindings
  - see the man page for more information

Set of RN-like keybindings for XRN
  (thanks to Jeff Wallace <jeffw@scam.Berkeley.EDU>)

New configuration parameter: SUBJECTS (config.h)
  - the number of subject lines to prefetch when doing a backwards
    subject search.  The default is 10

turning off kill file support:
  - for those of you that don't use kill files, the searching 
    for kill files can be turned off.  The kill buttons remain
    if you want to add something to a kill file, but they will
    not be processed.  See the +/-killFiles option.

ngLastGroup changed to ngPrevGroup
  - last group confused some people who thought it meant go to
    the last group displayed in the newsgroup index.

new button in article specific pane: print
  - print an article, uses the 'printCommand' resource/command line option
    (defaults to 'enscript')

new button in composition pane: include file
  - includes a file in a posting - like Meta-I in the text
    widget, but: (1) does not screw up your keyboard bindings,
    and (2) has an accelerator.

including an article now only includes the text (strips the header).
  - this can be changed via the 'includeHeader' option.
  (thanks to Paul Raveling <raveling@isi.edu>)

the .newsrc file can now be automatically updated when leaving article
  mode - see the `updateNewsrc' option.

slightly better KILL file support
  - killing based on author name supported
  - more formats of kill file entries supported

articles can be saved into newsgroup `folders', like 'xmh'.  see the
  saveMode option (thanks to Paul Raveling <raveling@isi.edu>)

More ways to specify the domain, hidden host, new hidden path, ...
  (thanks to Frederick M. Avolio (avolio@decuac.dec.com)
  - see config.h

USC ISI app-defaults file for XRN included (isi.app-defaults)
  (thanks to Paul Raveling <raveling@isi.edu>)

'abort' option in the death notifier dialog now dumps core in
the real stack rather than the signal stack (thanks to KJ Pires
<kjpires@ic.Berkeley.EDU).

Compiles with GCC.


XRN release (6.0):

Man page now even better reflects reality.

Much faster startup and rescan.

Can specify the order and number of buttons for each mode via
X resources or the command line: ngButtonList, addButtonList,
allButtonList, artButtonList, artSpecButtonList.

Post button exported to Newsgroup mode so you can post to
  newsgroups with no available articles.

Next Newsgroup works. 

Cleaned up included articles in composition windows

Bug fixes
  - fixed sending articles/messages with editorCommand
     (always would be sent)
  - loss of keybindings after dialog pop up attributed to
    window manager problems (gwm, hpwm, and sometimes twm and mwm).
    Key bindings are not lost when using dxwm, uwm.
    [VERY STRANGE]

Organization field can be defaulted in config.h

Compose windows are now topLevelShells rather than transientShells



New XRN release (5.7):

Bug fixes



New XRN release (5.6):

Kill Files
  - new commands (session kill, local kill, global kill)

Bug fixes

  - core dumps

Organization and Reply-To fields in postings can now be specified
via X resources or the command line.

Man page now better reflects reality.

Imakefile

RCS ID's



New XRN release (5.5):

line eater bug fix


New XRN release (5.4):

Changes from the last release of XRN:

- considerably less memory usage

  XRN uses a very simple data structure for storing information
  about newsgroups and articles.  For every newsgroup, an array
  the size of the number of articles available in that group
  is created.  This causes XRN to grow to 2.5 to 3Meg at most
  sites (at UCB, we have 650 groups and 2 week expiration, and
  XRN groups to 3Meg).  However there is no reason to keep article
  arrays for groups that you are not subscribed to. 

  Bill Webb (IBM AWD Palo Alto, ...!uunet!ibmsupt!webb) sent in a
  set of patches to have XRN only create article arrays for subscribed
  to groups.  This decreases the memory from 3Meg to 900k (for us).
  The amount you save will depend on what percentage of the newsgroups
  that you subscribe to.

- better nntp server error messages (sq)

  The messages XRN gives to the user for NNTP failures don't give
  you much information.   Ian Darwin (ian@sq.sq.com) sent in a set
  of patches to improve the error messages.

- alternative newsrcfile location (uiuc)

  Many people like to have xrn look for a newsrc file based on the
  particular server being used.  Dirk Grunwald (grunwald@flute.cs.uiuc.edu)
  sent in a set of patches to cause xrn to look for a newsrc file
  of the form <newsrcFile>-<nntpServer> before looking for just
  <newsrcFile>.

- includeSep

  A new Xdefault has been added to get rid of the "> " characters
  put in front of included messages.  Xdefault:
	
	    includeSep: on/off

  Command Line:

	    +/-includeSep

- header lines are no longer broken

  The last release included code to break long lines in news postings
  to reasonable values.  Unfortunately it would also break header
  lines (which is not allowed).  This version does not break the lines.

- updated man page

  The man page has been updated to reflect the current state of XRN.

- double click

  [note: this feature has not been added to the man page - it still
  has some problems]

  Double clicking on a newgroup entry will send you to the group.
  Double clicking on an article entry will display the article.



		Rick Spickelmier (ricks@ic..berkeley.edu)
		Ellen Sentovich (ellen@ic..berkeley.edu)

